package anune.util;

import java.util.Random;


public class Utils {
	
	private static final Random SEED_RNG = new Random();
	private static Random rng = new Random(0);
	
	
	public static void seed(long seed) {
		rng = new Random(seed);
	}
	
	
	public static long generateSeed() {
		return SEED_RNG.nextLong();
	}
	
	
	/**
	 * Seed random.
	 */
	public static void seed() {
		seedRandom();
	}
	
	
	public static void seedRandom() {
		rng = new Random();
	}
	
	
	/**
	 * Returns a pseudorandom double value between 0.0 and 1.0.
	 * @return 
	 */
	public static double randomDouble() {
		return rng.nextDouble();
	}
	
	
	/**
	 * Returns a pseudorandom float value between 0.0 and 1.0.
	 * @return 
	 */
	public static float randomFloat() {
		return rng.nextFloat();
	}
	
	/**
	 * Returns a pseudorandom integer between min (inclusive) and max (exclusive).
	 * @param min
	 * @param max
	 * @return 
	 */
	public static int randomInt(int min, int max) {
		return rng.nextInt(max - min) + min;
	}
	
	
	/**
	 * Returns a pseudorandom integer between 0 (inclusive) and max (exclusive).
	 * @param max
	 * @return 
	 */
	public static int randomInt(int max) {
		return rng.nextInt(max);
	}
	
	
	public static int randomInt() {
		return rng.nextInt();
	}
	
	
	public static long randomLong() {
		return rng.nextLong();
	}
	
	
	public static boolean randomEvent(double prob) {
		return randomDouble() <= prob;
	}
	
	
	public static double randomGausian(double mean, double std) {
		return rng.nextGaussian() * std + mean;
	}
	
	
}

