package creativebehaviour.ea;

import anune.ANN;
import creativebehaviour.models.ann.ANNCreature;
import creativebehaviour.models.Creature;
import creativebehaviour.models.ann.NetworkFactory;
import creativebehaviour.models.physical.TreeGenotype;
import creativebehaviour.models.ann.WeightsGenotype;
import eval.models.Genotype;
import eval.models.Phenotype;
import eval.models.Population;
import eval.util.Config;

/**
 *
 * @author Endre
 */
public class NetworkWeightsEA extends BrainEA {

	
	public NetworkWeightsEA(Config cfg) {
		super(cfg);
	}
	
	
	@Override
	public Population generateInitalPopulation(int size) {
		Population pop = new Population(size);
		WeightsGenotype wg;
		
		// Removed due to bug when running ann full with creature_ea mutation rate=1.0 (or >0.0).
//		if (currentTree.behaviourGenotype != null) {
//			wg = (WeightsGenotype) currentTree.behaviourGenotype;
//		}
//		else {
		ANN brain = NetworkFactory.makeANN(currentTree.tree);
		int nrOfWeights = brain.getWeightsCount();
		int nrOfBiases = brain.getBiasesCount();
		int nrOfTaus = brain.getTausCount();
		int nrOfGains = brain.getGainsCount();

		wg = new WeightsGenotype(nrOfWeights, nrOfBiases, nrOfTaus, nrOfGains);
		currentTree.setBehaviourGenotype(wg);
//		}
		
		for (int i = 0; i < size; i++) {
			Creature c = new ANNCreature(new TreeGenotype(currentTree), new WeightsGenotype(wg));
			pop.add(c);
		}
		
		return pop;
	}
	

	@Override
	public Phenotype generatePhenotype(Genotype g) {
		WeightsGenotype wg = (WeightsGenotype) g;
		return new ANNCreature(new TreeGenotype(currentTree), wg);
	}
	
	
	/**
	 * Set the creature entity tree to evolve weights for.
	 * @param tg
	 */
	public void setCurrentTree(TreeGenotype tg) {
		this.currentTree = tg;
	}
	
}
