package creativebehaviour.ents.misc;

/**
 *
 * @author Endre
 */
public interface OutputEntity {
	
	/**
	 * Perform the appropriate action for this entity.
	 * @param value The activation level for the action, in the range 0..1 (in most cases). 
	 * @return The cost associated with performing this action.
	 */
	public double performAction(double value);
	
	/**
	 * Perform the appropriate action for this entity. The origin of each element must
	 * match the order defined in Variable, in order for the legends to be correct.
	 * @param activation
	 * @return 
	 */
	public double performActions(double[] activation);
	
	//public Variable[] getOutputlegend();
	
}
