package creativebehaviour.ents.wrapper;

import creativebehaviour.ents.Entity;
import creativebehaviour.ents.misc.EntType;

/**
 *
 * @author Bjørnar W. Alvestad
 */
public class NullWrapper extends Wrapper {

	public NullWrapper() {
		super(null);
	}
	
	@Override
	public void mutate(double prob) {
	}

	@Override
	public Entity createEntity() {
		throw new UnsupportedOperationException("Invalid createEntity call to NullWrapper.");
	}
	
	@Override
	public boolean isSensor() {
		return false;
	}
	
	@Override
	public boolean isActuator() {
		return false;
	}

	@Override
	public Wrapper deepCopy() {
		return new NullWrapper();
	}

	@Override
	public double calcUpkeep() {
		return 0;
	}

	@Override
	public EntType getEntType() {
		return null;
	}

}
