package creativebehaviour.ents.wrapper;

import creativebehaviour.ents.Entity;
import creativebehaviour.ents.misc.EntType;
import creativebehaviour.util.tree.TreeElement;
import java.io.Serializable;

/**
 *
 * @author Bjørnar W. Alvestad
 */
public abstract class Wrapper implements Serializable, TreeElement<Wrapper> {
	
	public final int ENT_ATTACH_POINTS;
	public final EntType entType;
	
	
	public Wrapper(int ENT_ATTACH_POINTS, EntType entType) {
		this.ENT_ATTACH_POINTS = ENT_ATTACH_POINTS;
		this.entType = entType;
	}

	
	/**
	 * Default constructor with 0 attach points.
	 * @param entType
	 */
	public Wrapper(EntType entType) {
		this(0, entType);
	}

	
	@Override
	protected Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
	
	
	public abstract boolean isSensor();
	public abstract boolean isActuator();
	public abstract void mutate(double prob);
	public abstract Entity createEntity();
	public abstract double calcUpkeep();
	public abstract EntType getEntType();
	
	
}
