/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package creativebehaviour.models;

import creativebehaviour.models.physical.EntityParseException;
import creativebehaviour.models.physical.TreeGenotype;
import creativebehaviour.simulation.World;
import creativebehaviour.util.Utils;
import java.io.IOException;
import java.text.ParseException;

/**
 *
 * @author Endre
 */
public class BenchmarkFightingCreature extends Creature {
	
	public BenchmarkFightingCreature() throws IOException, EntityParseException {
		super(TreeGenotype.readFromTxtFile("benchmark_fighting.txt"), null);
	}
	
	public BenchmarkFightingCreature(BenchmarkFightingCreature c) {
		super(c.treeGenotype, null);
	}
	
	@Override
	public Creature copy() {
		return new BenchmarkFightingCreature( this );
	}

	@Override
	protected void customCreatureTick(float[] sensorData, float[] actuatorBuffer) {
		// TODO fighting creature behaviour
		// sensorData should be:
		//		[0]: HP
		//		[1]: Eye 1 Dist
		//		[2]: Eye 1 Dir
		//		[3]: Eye 2 Dist
		//		[4]: Eye 2 Dir
		
		// actuatorBuffer sould be:
		
		//		[0]: Body Move
		//		[1]: Body Turn
		//		[2]: Motor
		//		[3]: Arm 1-1
		//		[4]: Arm 1-2
		//		[5]: Arm 2-1
		//		[6]: Arm 2-2
		
		float bodyMove = 0;
		float bodyTurn = 0;
		float motor = 0;
		if (sensorData[1] <= 1 || sensorData[3] <= 1) {
			bodyTurn = 0.5f;
			bodyMove = 2.0f;
			motor = 2.0f;
		}
		else {
			bodyTurn = 3.0f;
			bodyMove = 2.0f;
		}
		
		actuatorBuffer[0] = Utils.randomFloat();
		actuatorBuffer[1] = Utils.randomFloat();
		actuatorBuffer[2] = Utils.randomFloat();
	}
	
}
