/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package creativebehaviour.models;

import creativebehaviour.models.physical.TreeGenotype;
import creativebehaviour.ents.Entity;
import creativebehaviour.ents.misc.OutputEntity;
import creativebehaviour.models.physical.EntityParseException;
import creativebehaviour.simulation.World;
import creativebehaviour.util.Utils;
import java.io.IOException;
import java.text.ParseException;

/**
 *
 * @author Endre
 */
public class BenchmarkMovingCreature extends Creature {
	
	public BenchmarkMovingCreature() throws IOException, EntityParseException {
		super(TreeGenotype.readFromTxtFile("benchmark_moving.txt"), null);
	}
	
	public BenchmarkMovingCreature(BenchmarkMovingCreature c) {
		super(c.treeGenotype, null);
	}
	
	@Override
	public void tick(World world) {
		// This creature is only a body and a motor
		for (OutputEntity output : outputEntities) {
			int num = ((Entity)output).entType.outputLegend.length;
			double[] activation = new double[num]; // XXX: optimize, ikke lag ny array her
			if (num == 2) {
				activation[0] = 3;
				activation[1] = 1;
			}
			else {
				activation[0] = 1;
			}
			Math.abs(output.performActions(activation)); // TODO: action cost absolute value
		}
		
		ticksLived++;

		position.add(velocity);


		if (world.WRAP_AROUND) {
			if (position.x > world.WIDTH) position.x = 0;
			if (position.x < 0) position.x = world.WIDTH;

			if (position.y > world.HEIGHT) position.y = 0;
			if (position.y < 0) position.y = world.HEIGHT;
		}
		else {
			if (position.x > world.WIDTH) position.x = world.WIDTH;
			if (position.x < 0) position.x = 0;

			if (position.y > world.HEIGHT) position.y = world.HEIGHT;
			if (position.y < 0) position.y = 0;
		}
		velocity.scale(0.8); // TODO: hardcoded friction 0.95
		
		if (invoulnerable) {
				invCounter--;
			}
		if (invCounter <= 0) {
			invCounter = 30;
			invoulnerable = false;
		}
	}

	@Override
	public Creature copy() {
		return new BenchmarkMovingCreature( this );
	}

	@Override
	protected void customCreatureTick(float[] sensorData, float[] actuatorBuffer) {
		return;
	}
	
}
