package creativebehaviour.models.neat;

import creativebehaviour.models.Creature;
import creativebehaviour.models.physical.TreeGenotype;
import eval.models.Genotype;

/**
 *
 * @author Endre
 */
public class NeatCreature extends Creature {
	
	

	/** The genotype for this type of creature. */
	private final NeatGenotype neatGenotype;
	
	/** The Neural network. */
	private final NeatANN brain;
	
	
	public NeatCreature(TreeGenotype treeGenotype, NeatGenotype neatGenotype) {
		super(treeGenotype, neatGenotype);
		
		this.neatGenotype = neatGenotype;
		
		this.brain = new NeatANN(neatGenotype);
		
	}
	
	
	/**
	 * Copy-constructor.
	 * @param original 
	 */
	public NeatCreature(NeatCreature original) {
		this(new TreeGenotype(original.treeGenotype), new NeatGenotype(original.neatGenotype));
		setEqual(original);
	}
	
	@Override
	protected void customCreatureTick(float[] sensorData, float[] actuatorBuffer) {
		System.arraycopy(brain.run(sensorData), 0, actuatorBuffer, 0, actuatorBuffer.length);
	}

	
	@Override
	public Creature copy() {
		return new NeatCreature(this);
	}

	
	@Override
	public NeatGenotype getGenotype() {
		return neatGenotype;
	}
	
}
