package creativebehaviour.util;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Properties;

/**
 *
 * @author Bjørnar W. Alvestad
 */
public class ReadableProperties extends Properties {

	public ReadableProperties() {
		
	}
	
	
	public void loadFromFile(String file) throws IOException {
		try (BufferedInputStream bis = new BufferedInputStream(new FileInputStream(file))) {
			load(bis);
		}
	}
	
	
	public void storeToFile(String file, String comment) throws IOException {
		try (BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(file, false))) {
			store(bos, comment);
		}
	}
	
	
	
}
