package eval.ea;

import java.io.FileWriter;
import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;



public class EAResults  implements Serializable {
	
	public ArrayList<Double> fitness_averages;
	public ArrayList<Double> fitness_maximums;
	public ArrayList<Double> fitness_deviations;

	public EAResults() {
	}

	public EAResults(ArrayList<Double> fitness_averages, ArrayList<Double> fitness_maximums, ArrayList<Double> fitness_deviations) {
		this.fitness_averages = fitness_averages;
		this.fitness_maximums = fitness_maximums;
		this.fitness_deviations = fitness_deviations;
	}
	
	public void writeExcelCompatibleTable(String outputfile) {
		writeExcelCompatibleTable(outputfile, false);
	}
	
	public void writeExcelCompatibleTable(String outputfile, boolean csv) {
		String separator = csv ? "," : "\t";
		try {
			FileWriter fw = new FileWriter(outputfile);
			
			fw.write("BEST");
			fw.write(separator);
			fw.write("AVG");
			fw.write(separator);
			fw.write("SD");
			fw.write("\n");
			
			for (int i = 0; i < fitness_averages.size(); i++) {
				fw.write(String.valueOf(fitness_maximums.get(i)));
				fw.write(separator);
				fw.write(String.valueOf(fitness_averages.get(i)));
				fw.write(separator);
				fw.write(String.valueOf(fitness_deviations.get(i)));
				fw.write("\n");
			}
			
			fw.close();
		} catch(IOException e){
			System.err.println("ERROR WRITING TO FILE: "+ e.getMessage());
		}
	}
}
