package eval.ea.selection.adult;

import eval.models.Phenotype;
import eval.models.Population;
import eval.util.roulette.Roulette;


public class GenerationalMixingAdultSelection extends AdultSelection {

	
	@Override
	public void selectAdults(Population offspring, Population population, int n, boolean maximize) {
		Roulette<Phenotype> roulette = new Roulette<>(offspring.getCount() + population.getCount());
		roulette.addAll(offspring, maximize);
		roulette.addAll(population, maximize);
		
		population.clear();
		for (int i = 0; i < n; i++) {
			population.add(roulette.spin(true));
		}
	}
	
}
