package eval.ea.selection.parent;

import eval.models.Phenotype;
import eval.models.Population;
import java.util.ArrayList;
import java.util.List;
import eval.util.Pair;
import eval.util.roulette.Roulette;


public class ProportionateParentSelection extends ParentSelection {

	@Override
	public List<Pair<Phenotype>> selectParents(Population p, int n, boolean maximize) {
		Roulette<Phenotype> rw = new Roulette<>(p.getCount());
		rw.addAll(p, maximize);
		ArrayList<Pair<Phenotype>> parents = new ArrayList<>(n);
		
		for (int i = 0; i < n; i++) {
			Pair<Phenotype> pair = new Pair<>(rw.spin(false), rw.spin(false));
			parents.add(pair);
		}
		
		return parents;
	}

}
