package eval.ea.selection.parent;

import eval.models.Phenotype;
import eval.models.Population;
import java.util.ArrayList;
import java.util.List;
import eval.util.Pair;
import eval.util.roulette.Roulette;


public class SigmaScalingParentSelection extends ParentSelection {

	@Override
	public List<Pair<Phenotype>> selectParents(Population p, int n, boolean maximize) {
		if (!maximize)
			throw new UnsupportedOperationException("Minimization in SigmaScalingParentSelection is not implemented.");
		
		double fitnessAvg = p.getAvgFitness();
		double standardDev = p.getStdFitness();
		
		Roulette<Phenotype> rw = new Roulette<>(p.getCount());
		
		for (Phenotype i : p) {
			rw.add(i, 1 + (i.getFitness() - fitnessAvg) / (2 * standardDev));
		}
		
		ArrayList<Pair<Phenotype>> parents = new ArrayList<>(n);
		
		for (int i = 0; i < n; i++) {
			Pair<Phenotype> pair = new Pair<>(rw.spin(false), rw.spin(false));
			parents.add(pair);
		}
		
		return parents;
	}

}
