package eval.example;

import eval.ea.EA;
import eval.models.BinaryGenotype;
import eval.models.Genotype;
import eval.models.Phenotype;
import eval.models.Population;
import eval.util.Config;
import eval.util.Utils;



public class LOLZEA extends EA {
	
	private int bitcount = 40;
	private int z = 21;

	public LOLZEA(Config cfg) {
		super(cfg);
	}


	@Override
	public Population generateInitalPopulation(int size) {
		Population pop = new Population(size);
		for (int i = 0; i < size; i++) {
			BinaryGenotype g = new BinaryGenotype(bitcount);
			for (int j = 0; j < bitcount; j++) {
				g.bits[j] = Utils.randomEvent(0.5);
			}
			LOLZPhenotype p = new LOLZPhenotype(g, z);
			pop.add(p);
		}
		return pop;
	}

	
	@Override
	public Phenotype generatePhenotype(Genotype g) {
		LOLZPhenotype pheno = new LOLZPhenotype(g, z);
		return pheno;
	}

	
}
