package eval.example;

import eval.models.BinaryGenotype;
import eval.models.Genotype;
import eval.models.Phenotype;



public class OneMaxPhenotype extends Phenotype {

	private int    onecount;
	private int[]  values;
	
	
	public OneMaxPhenotype(Genotype g) {
		super(g);
	}

	
	@Override
	public Genotype getGenotype() {
		return genotype;
	}

	
	
	@Override
	public double calculateFitness() {
		BinaryGenotype geno = (BinaryGenotype)genotype;
		onecount = 0;
		values = new int[geno.bits.length];
		for (int i = 0; i < values.length; i++) {
			values[i] = geno.bits[i] ? 1 : 0;
			onecount += geno.bits[i] ? 1 : 0;
		}
		
		int value = 0;
		for (int n : values) {
			value += n;
		}
		
		return value / (double)values.length;
	}

	
	@Override
	public String toString() {
		BinaryGenotype geno = (BinaryGenotype)genotype;
		StringBuilder gstr = new StringBuilder();
		for (int i = 0; i < geno.bits.length; i++) {
			gstr.append(geno.bits[i] ? '|' : '_');
		}
		return "OneMaxPhenotype{" + gstr + ", ones=" + onecount +'}';
	}
}
