/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package eval.models;

import eval.util.Utils;

/**
 *
 * @author Viktor
 */
public class CharGenotype extends Genotype{
	
	public char[] str;
	
	public CharGenotype(int len){
		this.str = new char[len];
	}
	
	public CharGenotype(String str){
		this.str = new char[str.length()];
		for (int i = 0; i < str.length(); i++) {
			this.str[i] = str.charAt(i);
		}
	}
	public CharGenotype(char[] str){
		this.str = new char[str.length];
		System.arraycopy(str, 0, this.str, 0, str.length);
	}
	

	@Override
	public Genotype copy() {
		return new CharGenotype(this.str);
	}

	
	@Override
	public Genotype crossover(Genotype g, Crossover type) {
		switch(type){	
			case ONE_POINT: return onePointCrossover((CharGenotype)g);
			default:
				throw new AssertionError(type.name());
		}	
	}
	
	
	private CharGenotype onePointCrossover(CharGenotype g){
		int splitIndex = Utils.randomInt(this.str.length);
		char[] bits = new char[this.str.length];
		System.arraycopy(this.str, 0, bits, 0, splitIndex);
		System.arraycopy(g.str, splitIndex, bits, splitIndex, bits.length - splitIndex);
		return new CharGenotype(bits);
	}
	

	@Override
	public void mutate(double prob) {
		for (int i = 0; i < str.length; i++){
			if (Utils.randomDouble() < prob) {
				this.str[i] = (char)(Utils.randomInt(65, 90));
			}
		}
	}

	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < this.str.length; i++) {
			sb.append(str[i]);
		}
		return "StringGenotype{" + sb.toString() + '}';
	}

}
