package eval.models;

import java.io.Serializable;

/**
 *
 * @author Endrus
 */
public abstract class Genotype implements Serializable {
	
	public abstract Genotype copy();
	public abstract Genotype crossover(Genotype g, Crossover type);
	/**
	 * 
	 * @param g The other parent
	 * @param type what kind of crossover to perform, i.e. ONE_POINT or UNIFORM
	 * @param isBestParent a parameter for passing down which parent had the highest fitness
	 *					   1  -> this is best parent
	 *					   0  -> both parents are equally fit
	 *					   -1 -> other parent is best parent
	 * @return 
	 */
	public Genotype crossover(Genotype g, Crossover type, int isBestParent) {
		return this.crossover(g, type);
	}
	public abstract void mutate(double prob);
	
}
