package creativebehaviour.ea;

import creativebehaviour.models.fuzzy.FuzzyCreature;
import creativebehaviour.models.fuzzy.FuzzyGenotype;
import eval.models.Genotype;
import eval.models.Phenotype;
import eval.models.Population;
import eval.util.Config;

/**
 *
 * @author Bjørnar W. Alvestad
 */
public class FuzzyEA extends BrainEA {
	
	public FuzzyEA(Config cfg) {
		super(cfg);
	}
	
	
	@Override
	public Population generateInitalPopulation(int size) {
		Population pop = new Population(size);
		
		FuzzyGenotype fg;
		
		// Not implemented................
		if (currentTree.behaviourGenotype != null) {
			fg = (FuzzyGenotype) currentTree.behaviourGenotype; // Fuzzy has not implemented this yet...
		}
		else {
			fg = new FuzzyGenotype(currentTree);
			currentTree.setBehaviourGenotype(fg);
		}
		// ...............................
		
		for (int i = 0; i < size; i++) {
			fg = new FuzzyGenotype(currentTree); // ...just create random genotype each time
			FuzzyCreature c = new FuzzyCreature(fg);
			pop.add(c);
		}
		
		return pop;
	}

	
	@Override
	public Phenotype generatePhenotype(Genotype g) {
		return new FuzzyCreature((FuzzyGenotype)g);
	}
	
}
