package creativebehaviour.fuzzy;

import creativebehaviour.ents.Entity;
import java.io.Serializable;

/**
 *
 * @author Bjørnar W. Alvestad
 */
public class EntityVariable implements Serializable {

	public final Entity ent;
	public final int var;
	public final int index;
	
	
	public EntityVariable(Entity ent, int var, int index) {
		this.ent = ent;
		this.var = var;
		this.index = index;
	}
	
	
	public EntityVariable(Entity ent, Variable var, int index) {
		this(ent, Variable.indexOf(var), index);
	}
	
	
	public Variable getVar() {
		return Variable.getVar(var);
	}
	

	@Override
	public String toString() {
		return ent.entType.name() + index + "." + getVar().name;
	}
	
}
