package creativebehaviour.fuzzy;

import creativebehaviour.fuzzy.memberfunc.MembershipFunc;
import java.io.Serializable;

/**
 *
 * @author Bjørnar W. Alvestad
 */
public class FuzzyValue implements Serializable {
	
	public final String linguisticName;
	public final MembershipFunc membershipFunction;
	
	
	
	public FuzzyValue(String linguisticName, MembershipFunc membershipFunction) {
		this.linguisticName = linguisticName;
		this.membershipFunction = membershipFunction;
	}

	
	/**
	 * Copy constructor.
	 * @param original 
	 */
	FuzzyValue(FuzzyValue original) {
		this.linguisticName = original.linguisticName;
		this.membershipFunction = original.membershipFunction.copy();
	}

	
	@Override
	public String toString() {
		return linguisticName + " " + membershipFunction.toString();
	}
	
	
}
