package creativebehaviour.fuzzy;

import creativebehaviour.fuzzy.memberfunc.MembershipFunc;
import creativebehaviour.fuzzy.memberfunc.MembershipFunctions;
import static creativebehaviour.fuzzy.memberfunc.MembershipFunctions.*;
import creativebehaviour.graphics.MainFrame;
import creativebehaviour.models.fuzzy.FuzzyCreature;
import creativebehaviour.models.fuzzy.FuzzyGenotype;
import creativebehaviour.models.physical.TreeGenotype;
import creativebehaviour.simulation.FoodWorld;
import creativebehaviour.simulation.Simulation;
import creativebehaviour.simulation.World;
import creativebehaviour.simulation.WorldFactory;
import creativebehaviour.simulation.WorldType;
import creativebehaviour.util.Utils;
import eval.models.Crossover;
import eval.models.Genotype;
import java.util.Locale;


/**
 *
 * @author Bjørnar W. Alvestad
 */
public class MainTest {
	
	public static void main(String[] args) throws Exception {
		
		
		
//		FuzzyVariable v = new FuzzyVariable("shit", 0, 10);
//		v.addFuzzyValue(TRIANGLE.createInstance(3, 5, 7));
//		v.addFuzzyValue(GRADE.createInstance(4, 10));
//		
//		double[] buff = v.createBuffer();
//		double num = 0.0;
//		double denom = 0.0;
//		
//		for (double i = 0; i < 10; i += 0.001) {
//			v.read(i, buff);
//			double y = Math.max(buff[0], buff[1]);
//			y = Math.min(y, 0.5);
//			
//			num += i*y;
//			denom += y;
//		}
//		
//		System.out.println(num / denom);

		Utils.seed();
		
		TreeGenotype tg = TreeGenotype.readFromTxtFile("test.txt");
		FuzzyGenotype fg = new FuzzyGenotype(tg);
		System.out.println(fg);
		FuzzyCreature c = new FuzzyCreature(fg);
		
//		Simulation sim = new Simulation(WorldType.STANDARD, 1);
//		sim.addCreature(c);
//		sim.runSimulation();
		
		World world = WorldFactory.makeFoodWorld();
		world.addCreature(c);
//		c.addEnergy(-400);
		
		MainFrame frame = new MainFrame(900, 800, world);
		frame.setLocationRelativeTo(null);
		frame.startRenderThread();
		frame.setVisible(true);
	}
	
}
