package creativebehaviour.fuzzy;

import java.io.Serializable;
import java.util.Objects;

/**
 *
 * @author Bjørnar W. Alvestad
 */
public abstract class Set implements Serializable {

	public final int var;
	
	
	public Set(int var) {
		this.var = var;
	}
	
	
	public String getName() {
		return getVar().name;
	}
	
	
	public Variable getVar() {
		return Variable.getVar(var);
	}

	
	@Override
	public int hashCode() {
		int hash = 5;
		hash = 37 * hash + Objects.hashCode(this.var);
		return hash;
	}

	
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		final Set other = (Set) obj;
		if (!Objects.equals(this.var, other.var)) {
			return false;
		}
		return true;
	}
	
	
	
}
