package creativebehaviour.fuzzy;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Bjørnar W. Alvestad
 * @param <T>
 */
public class SetContainer<T extends Set> implements Serializable {
	
	private final List<T> sets;

	
	public SetContainer() {
		this.sets = new ArrayList<>();
	}
	
	
	public SetContainer(int size) {
		this.sets = new ArrayList<>(size);
	}
	
	
	public void addSet(T set) {
		if (sets.contains(set)) throw new RuntimeException("Set \"" + set.getName() + "\" already added to set container.");
		sets.add(set);
	}
	
	
	public int getSize() {
		return sets.size();
	}
	
	
	public List<T> getSets() {
		return sets;
	}
	
}
