package creativebehaviour.fuzzy.memberfunc;

import java.io.Serializable;

/**
 *
 * @author Bjørnar W. Alvestad
 */
public abstract class MembershipFunc implements Serializable {
	
	protected final MembershipFunctions memFunEnum;

	MembershipFunc(MembershipFunctions memFunEnum) {
		this.memFunEnum = memFunEnum;
	}
	
	
	public abstract double f(double x);
	public abstract void normalize(double normalizeFactor);
	public abstract MembershipFunc copy();
	
	
	@Override
	public String toString() {
		return getName();
	}
	
	
	public int getNumParams() {
		return memFunEnum.numParameters;
	}
	
	
	public boolean isReversable() {
		return memFunEnum.reversable;
	}
	
	
	public String getName() {
		return memFunEnum.name();
	}
	
	
}
