package creativebehaviour.fuzzy.memberfunc;

/**
 *
 * @author Bjørnar W. Alvestad
 */
public class Triangle extends Trapezoid {
	
	/**
	 * Triangle:
	 * 
	 *          | 
	 *         / \
	 *      a / | \
	 *       /     \
	 * _____/...|...\_____
	 *     x0   c   x3
	 *        x1 x2
	 * 
	 * @param a Triangle slope.
	 * @param c Triangle center.
	 */
	Triangle(double a, double c) {
		super(a, c, 0, MembershipFunctions.TRIANGLE);
	}
	
	
	/**
	 * 
	 * @param x 
	 */
	Triangle(double[] x) {
		super(new double[]{x[0], x[1], x[1], x[2]}, MembershipFunctions.TRIANGLE);
		if (x.length != 3) throw new IllegalArgumentException("Length of x-points table passed to Triangle must be 3. Is " + x.length + ".");
	}
	
	
	Triangle(Triangle original, boolean ignored) {
		super(original);
	}
	
	
	@Override
	public MembershipFunc copy() {
		return new Triangle(this, false);
	}
	
	
	
}
