package creativebehaviour.fuzzy.rule;

import java.util.function.DoubleBinaryOperator;

/**
 *
 * @author Bjørnar W. Alvestad
 */
public enum Operation {
	AND((double x, double y) -> Math.min(x, y)),
	OR((double x, double y) -> Math.max(x, y));

	private DoubleBinaryOperator operator;

	private Operation(DoubleBinaryOperator operator) {
		this.operator = operator;
	}

	public double evaluate(double x, double y) {
		return this.operator.applyAsDouble(x, y);
	}
}
