package creativebehaviour.fuzzy.rule;

import java.io.Serializable;
import java.util.ArrayList;

/**
 *
 * @author Bjørnar W. Alvestad
 */
public abstract class Rule implements Serializable {
	
	protected final ArrayList<RuleClause> clauses;
	protected final RuleClause thenClause;

	
	public Rule(ArrayList<RuleClause> clauses, RuleClause thenClause) {
		this.clauses = new ArrayList<>(clauses);
		this.thenClause = thenClause;
	}
	
	
	public Rule(Rule original) {
		this.thenClause = new RuleClause(original.thenClause);
		this.clauses = new ArrayList<>(original.clauses.size());
		original.clauses.forEach(c -> this.clauses.add(new RuleClause(c)));
	}
	
	
	public ArrayList<RuleClause> getClauses() {
		return clauses;
	}

	
	public RuleClause getThenClause() {
		return thenClause;
	}
	
	
	public abstract Rule copy();
	public abstract double eval(double[][] fuzzyData);
	
	
}
